import Vue from 'vue';
var Application = /** @class */ (function () {
    function Application(options) {
        this.vueClass = options.vue || Vue;
    }
    Application.initialize = function (options) {
        return new Application(options);
    };
    Application.prototype.load = function (contexts) {
        var _this = this;
        contexts.forEach(function (context) {
            var identifier = context.identifier;
            var instance = context.instanceConstructor.initialize();
            var selector = instance.el || "[instance='" + identifier + "']";
            var element = document.querySelector(selector);
            if (element) {
                var vueInstance = new _this.vueClass(instance.load(element));
                vueInstance.$instances = Application.instances;
                Application.instances.identifier = vueInstance;
            }
        });
    };
    Application.instances = {};
    return Application;
}());
export { Application };
//# sourceMappingURL=application.js.map